• POJ 2828 Buy Tickets


    Description

    Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue…

    The Lunar New Year was approaching, but unluckily the Little Cat still had schedules going here and there. Now, he had to travel by train to Mianyang, Sichuan Province for the winter camp selection of the national team of Olympiad in Informatics.

    It was one o’clock a.m. and dark outside. Chill wind from the northwest did not scare off the people in the queue. The cold night gave the Little Cat a shiver. Why not find a problem to think about? That was none the less better than freezing to death!

    People kept jumping the queue. Since it was too dark around, such moves would not be discovered even by the people adjacent to the queue-jumpers. “If every person in the queue is assigned an integral value and all the information about those who have jumped the queue and where they stand after queue-jumping is given, can I find out the final order of people in the queue?” Thought the Little Cat.

    Input

    There will be several test cases in the input. Each test case consists of N + 1 lines where N (1 ≤ N ≤ 200,000) is given in the first line of the test case. The next N lines contain the pairs of values Posi and Vali in the increasing order of i (1 ≤ i ≤ N). For each i, the ranges and meanings of Posi and Vali are as follows:

    • Posi ∈ [0, i − 1] — The i-th person came to the queue and stood right behind the Posi-th person in the queue. The booking office was considered the 0th person and the person at the front of the queue was considered the first person in the queue.
    • Vali ∈ [0, 32767] — The i-th person was assigned the value Vali.

    There no blank lines between test cases. Proceed to the end of input.

    Output

    For each test cases, output a single line of space-separated integers which are the values of people in the order they stand in the queue.

    Sample Input

    4
    0 77
    1 51
    1 33
    2 69
    4
    0 20523
    1 19243
    1 3890
    0 31492

    Sample Output

    77 33 69 51
    31492 20523 3890 19243

    Hint

    The figure below shows how the Little Cat found out the final order of people in the queue described in the first test case of the sample input.

    线段树的题目=。

    =

    线段树应该记录每一个点的前面有多少空格=。=

    策略:对输入的每一个点从后往前递推=。=,由于后面的点固定了以后前面的就能够固定了。

    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #include<algorithm>
    #include<limits.h>
    using namespace std;
    const int maxn=200000+10;
    struct node{
        int l,r;
        int sum;
    }t[maxn<<2];
    int pos[maxn],val[maxn],ans[maxn];
    void build(int rs,int l,int r)
    {
        t[rs].l=l;
        t[rs].r=r;
        t[rs].sum=r-l+1;
        if(l==r)
            return ;
        int mid=(l+r)>>1;
        build(rs<<1,l,mid);
        build(rs<<1|1,mid+1,r);
    
    }
    int update(int s,int rs)
    {
        t[rs].sum--;
        if(t[rs].l==t[rs].r)
            return t[rs].l;
        if(t[rs<<1].sum>=s)
            update(s,rs<<1);
        else
        {
            s-=t[rs<<1].sum;
            update(s,rs<<1|1);
        }
    }
    int main()
    {
        int n;
        while(~scanf("%d",&n))
        {
            build(1,1,n);
            for(int i=0;i<n;i++)
                scanf("%d%d",&pos[i],&val[i]);
            for(int i=n-1;i>=0;i--)
            {
                int num=update(pos[i]+1,1);
                ans[num-1]=val[i];
            }
            for(int i=0;i<n;i++)
                printf(i==n-1?"%d
    ":"%d ",ans[i]);
        }
        return 0;
    }
    


  • 相关阅读:
    leetcode ZigZag conversion(mediium) /java
    leetcode longest palindromic substring (medium) /java
    leetcode longest substring without repeating characters(medium) /java
    leetcode two_sum (easy) /java
    think_in_java_多态
    java复用类知识
    java找不到或无法加载主类
    java程序包不存在
    集合
    列表的增删改查
  • 原文地址:https://www.cnblogs.com/zsychanpin/p/6713184.html
Copyright © 2020-2023  润新知